/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.IOException;
import java.io.InputStream;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.media.Manager;
import javax.microedition.media.MediaException;
import javax.microedition.media.Player;
import org.netbeans.microedition.lcdui.SplashScreen;
import org.netbeans.microedition.lcdui.WaitScreen;
import org.netbeans.microedition.util.SimpleCancellableTask;

/**
 * @author jacob
 */
public class DTMFDial extends MIDlet implements CommandListener {

    private boolean midletPaused = false;

    //<editor-fold defaultstate="collapsed" desc=" Generated Fields ">//GEN-BEGIN:|fields|0|
    private Command cancelCommand;
    private Command okCommand;
    private Command cancelDial;
    private Command okDial;
    private SplashScreen splashScreen;
    private List Menu;
    private Form dtmfSettings;
    private TextField pauseTF;
    private StringItem stringItem;
    private Spacer spacer;
    private TextField durationTF;
    private TextField emptyPrefixTF;
    private TextField replacPlusTF;
    private Form numberForm;
    private TextField numberField;
    private WaitScreen DialScreen;
    private Alert CantDialAlert;
    private Image phoneImg;
    private SimpleCancellableTask task;
    //</editor-fold>//GEN-END:|fields|0|
    int dtmfDuration = 200;
    int dtmfPause = 100;
    private final String dtmfvals = "0123456789ps";
    private SettingsManager sm;
    String emptyPrefix = "+45";
    String replacePlus = "00";

    //</editor-fold>
    //</editor-fold>
    /**
     * The HelloMIDlet constructor.
     */
    public DTMFDial() {
    }

    //<editor-fold defaultstate="collapsed" desc=" Generated Methods ">//GEN-BEGIN:|methods|0|
    //</editor-fold>//GEN-END:|methods|0|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: initialize ">//GEN-BEGIN:|0-initialize|0|0-preInitialize
    /**
     * Initilizes the application.
     * It is called only once when the MIDlet is started. The method is called before the <code>startMIDlet</code> method.
     */
    private void initialize() {//GEN-END:|0-initialize|0|0-preInitialize
        // write pre-initialize user code here
        splashScreen = new SplashScreen(getDisplay());//GEN-BEGIN:|0-initialize|1|0-postInitialize
        splashScreen.setTitle("splashScreen");
        splashScreen.setCommandListener(this);
        splashScreen.setFullScreenMode(true);
        splashScreen.setImage(getPhoneImg());
        splashScreen.setTimeout(1000);//GEN-END:|0-initialize|1|0-postInitialize
    // write post-initialize user code here
        sm = new SettingsManager(this);
        sm.readSettings();
    }//GEN-BEGIN:|0-initialize|2|
    //</editor-fold>//GEN-END:|0-initialize|2|
    //<editor-fold defaultstate="collapsed" desc=" Generated Method: startMIDlet ">//GEN-BEGIN:|3-startMIDlet|0|3-preAction
    /**
     * Performs an action assigned to the Mobile Device - MIDlet Started point.
     */
    public void startMIDlet() {//GEN-END:|3-startMIDlet|0|3-preAction
        // write pre-action user code here
        switchDisplayable(null, splashScreen);//GEN-LINE:|3-startMIDlet|1|3-postAction
    // write post-action user code here
    }//GEN-BEGIN:|3-startMIDlet|2|
    //</editor-fold>//GEN-END:|3-startMIDlet|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: resumeMIDlet ">//GEN-BEGIN:|4-resumeMIDlet|0|4-preAction
    /**
     * Performs an action assigned to the Mobile Device - MIDlet Resumed point.
     */
    public void resumeMIDlet() {//GEN-END:|4-resumeMIDlet|0|4-preAction
        // write pre-action user code here
        switchDisplayable(null, getMenu());//GEN-LINE:|4-resumeMIDlet|1|4-postAction
    // write post-action user code here
    }//GEN-BEGIN:|4-resumeMIDlet|2|
    //</editor-fold>//GEN-END:|4-resumeMIDlet|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: switchDisplayable ">//GEN-BEGIN:|5-switchDisplayable|0|5-preSwitch
    /**
     * Switches a current displayable in a display. The <code>display</code> instance is taken from <code>getDisplay</code> method. This method is used by all actions in the design for switching displayable.
     * @param alert the Alert which is temporarily set to the display; if <code>null</code>, then <code>nextDisplayable</code> is set immediately
     * @param nextDisplayable the Displayable to be set
     */
    public void switchDisplayable(Alert alert, Displayable nextDisplayable) {//GEN-END:|5-switchDisplayable|0|5-preSwitch
        // write pre-switch user code here
        Display display = getDisplay();//GEN-BEGIN:|5-switchDisplayable|1|5-postSwitch
        if (alert == null) {
            display.setCurrent(nextDisplayable);
        } else {
            display.setCurrent(alert, nextDisplayable);
        }//GEN-END:|5-switchDisplayable|1|5-postSwitch
    // write post-switch user code here
    }//GEN-BEGIN:|5-switchDisplayable|2|
    //</editor-fold>//GEN-END:|5-switchDisplayable|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: commandAction for Displayables ">//GEN-BEGIN:|7-commandAction|0|7-preCommandAction
    /**
     * Called by a system to indicated that a command has been invoked on a particular displayable.
     * @param command the Command that was invoked
     * @param displayable the Displayable where the command was invoked
     */
    public void commandAction(Command command, Displayable displayable) {//GEN-END:|7-commandAction|0|7-preCommandAction
        // write pre-action user code here
        if (displayable == DialScreen) {//GEN-BEGIN:|7-commandAction|1|57-preAction
            if (command == WaitScreen.FAILURE_COMMAND) {//GEN-END:|7-commandAction|1|57-preAction
                // write pre-action user code here
                switchDisplayable(getCantDialAlert(), getMenu());//GEN-LINE:|7-commandAction|2|57-postAction
            // write post-action user code here
            } else if (command == WaitScreen.SUCCESS_COMMAND) {//GEN-LINE:|7-commandAction|3|56-preAction
                // write pre-action user code here
                switchDisplayable(null, getNumberForm());//GEN-LINE:|7-commandAction|4|56-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|5|32-preAction
        } else if (displayable == Menu) {
            if (command == List.SELECT_COMMAND) {//GEN-END:|7-commandAction|5|32-preAction
                // write pre-action user code here
                MenuAction();//GEN-LINE:|7-commandAction|6|32-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|7|43-preAction
        } else if (displayable == dtmfSettings) {
            if (command == cancelCommand) {//GEN-END:|7-commandAction|7|43-preAction
                // write pre-action user code here
                switchDisplayable(null, getMenu());//GEN-LINE:|7-commandAction|8|43-postAction
            // write post-action user code here
            } else if (command == okCommand) {//GEN-LINE:|7-commandAction|9|41-preAction
                // write pre-action user code here
                dtmfDuration = Integer.parseInt(durationTF.getString());
                if (dtmfDuration > 300) {
                    dtmfDuration = 300;
                }
                dtmfPause = Integer.parseInt(pauseTF.getString());
                emptyPrefix = emptyPrefixTF.getString();
                replacePlus = replacPlusTF.getString();
                switchDisplayable(null, getMenu());//GEN-LINE:|7-commandAction|10|41-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|11|51-preAction
        } else if (displayable == numberForm) {
            if (command == cancelDial) {//GEN-END:|7-commandAction|11|51-preAction
                // write pre-action user code here
                switchDisplayable(null, getMenu());//GEN-LINE:|7-commandAction|12|51-postAction
            // write post-action user code here
            } else if (command == okDial) {//GEN-LINE:|7-commandAction|13|49-preAction
                // write pre-action user code here
                switchDisplayable(null, getDialScreen());//GEN-LINE:|7-commandAction|14|49-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|15|28-preAction
        } else if (displayable == splashScreen) {
            if (command == SplashScreen.DISMISS_COMMAND) {//GEN-END:|7-commandAction|15|28-preAction
                // write pre-action user code here
                switchDisplayable(null, getMenu());//GEN-LINE:|7-commandAction|16|28-postAction
            // write post-action user code here
            }//GEN-BEGIN:|7-commandAction|17|7-postCommandAction
        }//GEN-END:|7-commandAction|17|7-postCommandAction
    // write post-action user code here
    }//GEN-BEGIN:|7-commandAction|18|
    //</editor-fold>//GEN-END:|7-commandAction|18|
    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: Menu ">//GEN-BEGIN:|30-getter|0|30-preInit
    /**
     * Returns an initiliazed instance of Menu component.
     * @return the initialized component instance
     */
    public List getMenu() {
        if (Menu == null) {//GEN-END:|30-getter|0|30-preInit
            // write pre-init user code here
            Menu = new List("list", Choice.IMPLICIT);//GEN-BEGIN:|30-getter|1|30-postInit
            Menu.append("Dial phone number", null);
            Menu.append("Settings", null);
            Menu.append("Exit", null);
            Menu.setCommandListener(this);
            Menu.setSelectedFlags(new boolean[] { false, false, false });//GEN-END:|30-getter|1|30-postInit
        // write post-init user code here
        }//GEN-BEGIN:|30-getter|2|
        return Menu;
    }
    //</editor-fold>//GEN-END:|30-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Method: MenuAction ">//GEN-BEGIN:|30-action|0|30-preAction
    /**
     * Performs an action assigned to the selected list element in the Menu component.
     */
    public void MenuAction() {//GEN-END:|30-action|0|30-preAction
        // enter pre-action user code here
        String __selectedString = getMenu().getString(getMenu().getSelectedIndex());//GEN-BEGIN:|30-action|1|34-preAction
        if (__selectedString != null) {
            if (__selectedString.equals("Dial phone number")) {//GEN-END:|30-action|1|34-preAction
                // write pre-action user code here
                switchDisplayable(null, getNumberForm());//GEN-LINE:|30-action|2|34-postAction
            // write post-action user code here
            } else if (__selectedString.equals("Settings")) {//GEN-LINE:|30-action|3|35-preAction
                // write pre-action user code here
                switchDisplayable(null, getDtmfSettings());//GEN-LINE:|30-action|4|35-postAction
            // write post-action user code here
            } else if (__selectedString.equals("Exit")) {//GEN-LINE:|30-action|5|36-preAction
                // write pre-action user code here
                exitMIDlet();//GEN-LINE:|30-action|6|36-postAction
            // write post-action user code here
            }//GEN-BEGIN:|30-action|7|30-postAction
        }//GEN-END:|30-action|7|30-postAction
    // enter post-action user code here
    }//GEN-BEGIN:|30-action|8|
    //</editor-fold>//GEN-END:|30-action|8|


    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: okCommand ">//GEN-BEGIN:|40-getter|0|40-preInit
    /**
     * Returns an initiliazed instance of okCommand component.
     * @return the initialized component instance
     */
    public Command getOkCommand() {
        if (okCommand == null) {//GEN-END:|40-getter|0|40-preInit
            // write pre-init user code here
            okCommand = new Command("Ok", Command.OK, 0);//GEN-LINE:|40-getter|1|40-postInit
        // write post-init user code here
        }//GEN-BEGIN:|40-getter|2|
        return okCommand;
    }
    //</editor-fold>//GEN-END:|40-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: cancelCommand ">//GEN-BEGIN:|42-getter|0|42-preInit
    /**
     * Returns an initiliazed instance of cancelCommand component.
     * @return the initialized component instance
     */
    public Command getCancelCommand() {
        if (cancelCommand == null) {//GEN-END:|42-getter|0|42-preInit
            // write pre-init user code here
            cancelCommand = new Command("Cancel", Command.CANCEL, 0);//GEN-LINE:|42-getter|1|42-postInit
        // write post-init user code here
        }//GEN-BEGIN:|42-getter|2|
        return cancelCommand;
    }
    //</editor-fold>//GEN-END:|42-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: okDial ">//GEN-BEGIN:|48-getter|0|48-preInit
    /**
     * Returns an initiliazed instance of okDial component.
     * @return the initialized component instance
     */
    public Command getOkDial() {
        if (okDial == null) {//GEN-END:|48-getter|0|48-preInit
            // write pre-init user code here
            okDial = new Command("Ok", Command.OK, 0);//GEN-LINE:|48-getter|1|48-postInit
        // write post-init user code here
        }//GEN-BEGIN:|48-getter|2|
        return okDial;
    }
    //</editor-fold>//GEN-END:|48-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: cancelDial ">//GEN-BEGIN:|50-getter|0|50-preInit
    /**
     * Returns an initiliazed instance of cancelDial component.
     * @return the initialized component instance
     */
    public Command getCancelDial() {
        if (cancelDial == null) {//GEN-END:|50-getter|0|50-preInit
            // write pre-init user code here
            cancelDial = new Command("Cancel", Command.CANCEL, 0);//GEN-LINE:|50-getter|1|50-postInit
        // write post-init user code here
        }//GEN-BEGIN:|50-getter|2|
        return cancelDial;
    }
    //</editor-fold>//GEN-END:|50-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: dtmfSettings ">//GEN-BEGIN:|39-getter|0|39-preInit
    /**
     * Returns an initiliazed instance of dtmfSettings component.
     * @return the initialized component instance
     */
    public Form getDtmfSettings() {
        if (dtmfSettings == null) {//GEN-END:|39-getter|0|39-preInit
            // write pre-init user code here
            dtmfSettings = new Form("Settings", new Item[] { getDurationTF(), getPauseTF(), getSpacer(), getEmptyPrefixTF(), getReplacPlusTF(), getStringItem() });//GEN-BEGIN:|39-getter|1|39-postInit
            dtmfSettings.addCommand(getOkCommand());
            dtmfSettings.addCommand(getCancelCommand());
            dtmfSettings.setCommandListener(this);//GEN-END:|39-getter|1|39-postInit
        // write post-init user code here
        }//GEN-BEGIN:|39-getter|2|
        return dtmfSettings;
    }
    //</editor-fold>//GEN-END:|39-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: numberForm ">//GEN-BEGIN:|47-getter|0|47-preInit
    /**
     * Returns an initiliazed instance of numberForm component.
     * @return the initialized component instance
     */
    public Form getNumberForm() {
        if (numberForm == null) {//GEN-END:|47-getter|0|47-preInit
            // write pre-init user code here
            numberForm = new Form("Dial interface", new Item[] { getNumberField() });//GEN-BEGIN:|47-getter|1|47-postInit
            numberForm.addCommand(getOkDial());
            numberForm.addCommand(getCancelDial());
            numberForm.setCommandListener(this);//GEN-END:|47-getter|1|47-postInit
        // write post-init user code here
        }//GEN-BEGIN:|47-getter|2|
        return numberForm;
    }
    //</editor-fold>//GEN-END:|47-getter|2|
    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: numberField ">//GEN-BEGIN:|64-getter|0|64-preInit
    /**
     * Returns an initiliazed instance of numberField component.
     * @return the initialized component instance
     */
    public TextField getNumberField() {
        if (numberField == null) {//GEN-END:|64-getter|0|64-preInit
            // write pre-init user code here
            numberField = new TextField("Phone number", null, 32, TextField.PHONENUMBER);//GEN-LINE:|64-getter|1|64-postInit
        // write post-init user code here
        }//GEN-BEGIN:|64-getter|2|
        return numberField;
    }
    //</editor-fold>//GEN-END:|64-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: DialScreen ">//GEN-BEGIN:|53-getter|0|53-preInit
    /**
     * Returns an initiliazed instance of DialScreen component.
     * @return the initialized component instance
     */
    public WaitScreen getDialScreen() {
        if (DialScreen == null) {//GEN-END:|53-getter|0|53-preInit
            // write pre-init user code here
            DialScreen = new WaitScreen(getDisplay());//GEN-BEGIN:|53-getter|1|53-postInit
            DialScreen.setTitle("waitScreen");
            DialScreen.setCommandListener(this);
            DialScreen.setFullScreenMode(true);
            DialScreen.setImage(getPhoneImg());
            DialScreen.setTask(getTask());//GEN-END:|53-getter|1|53-postInit
        // write post-init user code here
        }//GEN-BEGIN:|53-getter|2|
        return DialScreen;
    }
    //</editor-fold>//GEN-END:|53-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: CantDialAlert ">//GEN-BEGIN:|60-getter|0|60-preInit
    /**
     * Returns an initiliazed instance of CantDialAlert component.
     * @return the initialized component instance
     */
    public Alert getCantDialAlert() {
        if (CantDialAlert == null) {//GEN-END:|60-getter|0|60-preInit
            // write pre-init user code here
            CantDialAlert = new Alert("alert", "Could not dial", null, null);//GEN-BEGIN:|60-getter|1|60-postInit
            CantDialAlert.setTimeout(Alert.FOREVER);//GEN-END:|60-getter|1|60-postInit
        // write post-init user code here
        }//GEN-BEGIN:|60-getter|2|
        return CantDialAlert;
    }
    //</editor-fold>//GEN-END:|60-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: task ">//GEN-BEGIN:|58-getter|0|58-preInit
    /**
     * Returns an initiliazed instance of task component.
     * @return the initialized component instance
     */
    public SimpleCancellableTask getTask() {
        if (task == null) {//GEN-END:|58-getter|0|58-preInit
            // write pre-init user code here
            task = new SimpleCancellableTask();//GEN-BEGIN:|58-getter|1|58-execute
            task.setExecutable(new org.netbeans.microedition.util.Executable() {
                public void execute() throws Exception {//GEN-END:|58-getter|1|58-execute
                    // write task-execution user code here
                    doDial(numberField.getString());
                }//GEN-BEGIN:|58-getter|2|58-postInit
            });//GEN-END:|58-getter|2|58-postInit
        // write post-init user code here
        }//GEN-BEGIN:|58-getter|3|
        return task;
    }
    //</editor-fold>//GEN-END:|58-getter|3|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: durationTF ">//GEN-BEGIN:|67-getter|0|67-preInit
    /**
     * Returns an initiliazed instance of durationTF component.
     * @return the initialized component instance
     */
    public TextField getDurationTF() {
        if (durationTF == null) {//GEN-END:|67-getter|0|67-preInit
            // write pre-init user code here
            durationTF = new TextField("Tone duration", "" + dtmfDuration, 32, TextField.NUMERIC);//GEN-LINE:|67-getter|1|67-postInit
        // write post-init user code here
        }//GEN-BEGIN:|67-getter|2|
        return durationTF;
    }
    //</editor-fold>//GEN-END:|67-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: pauseTF ">//GEN-BEGIN:|68-getter|0|68-preInit
    /**
     * Returns an initiliazed instance of pauseTF component.
     * @return the initialized component instance
     */
    public TextField getPauseTF() {
        if (pauseTF == null) {//GEN-END:|68-getter|0|68-preInit
            // write pre-init user code here
            pauseTF = new TextField("Pause duration", "" + dtmfPause, 32, TextField.NUMERIC);//GEN-LINE:|68-getter|1|68-postInit
        // write post-init user code here
        }//GEN-BEGIN:|68-getter|2|
        return pauseTF;
    }
    //</editor-fold>//GEN-END:|68-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: stringItem ">//GEN-BEGIN:|69-getter|0|69-preInit
    /**
     * Returns an initiliazed instance of stringItem component.
     * @return the initialized component instance
     */
    public StringItem getStringItem() {
        if (stringItem == null) {//GEN-END:|69-getter|0|69-preInit
            // write pre-init user code here
            stringItem = new StringItem("DTMF dialer", "Duration and pause values are in milliseconds. Maximum for duration is 300. ");//GEN-LINE:|69-getter|1|69-postInit
        // write post-init user code here
        }//GEN-BEGIN:|69-getter|2|
        return stringItem;
    }
    //</editor-fold>//GEN-END:|69-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: spacer ">//GEN-BEGIN:|70-getter|0|70-preInit
    /**
     * Returns an initiliazed instance of spacer component.
     * @return the initialized component instance
     */
    public Spacer getSpacer() {
        if (spacer == null) {//GEN-END:|70-getter|0|70-preInit
            // write pre-init user code here
            spacer = new Spacer(16, 1);//GEN-LINE:|70-getter|1|70-postInit
        // write post-init user code here
        }//GEN-BEGIN:|70-getter|2|
        return spacer;
    }
    //</editor-fold>//GEN-END:|70-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: phoneImg ">//GEN-BEGIN:|25-getter|0|25-preInit
    /**
     * Returns an initiliazed instance of phoneImg component.
     * @return the initialized component instance
     */
    public Image getPhoneImg() {
        if (phoneImg == null) {//GEN-END:|25-getter|0|25-preInit
            // write pre-init user code here
            try {//GEN-BEGIN:|25-getter|1|25-@java.io.IOException
                phoneImg = Image.createImage("/phone.png");
            } catch (java.io.IOException e) {//GEN-END:|25-getter|1|25-@java.io.IOException
                e.printStackTrace();
            }//GEN-LINE:|25-getter|2|25-postInit
        // write post-init user code here
        }//GEN-BEGIN:|25-getter|3|
        return phoneImg;
    }
    //</editor-fold>//GEN-END:|25-getter|3|













    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: emptyPrefixTF ">//GEN-BEGIN:|94-getter|0|94-preInit
    /**
     * Returns an initiliazed instance of emptyPrefixTF component.
     * @return the initialized component instance
     */
    public TextField getEmptyPrefixTF() {
        if (emptyPrefixTF == null) {//GEN-END:|94-getter|0|94-preInit
            // write pre-init user code here
            emptyPrefixTF = new TextField("Prefix to remove:", "" + emptyPrefix, 32, TextField.ANY);//GEN-LINE:|94-getter|1|94-postInit
            // write post-init user code here
        }//GEN-BEGIN:|94-getter|2|
        return emptyPrefixTF;
    }
    //</editor-fold>//GEN-END:|94-getter|2|

    //<editor-fold defaultstate="collapsed" desc=" Generated Getter: replacPlusTF ">//GEN-BEGIN:|95-getter|0|95-preInit
    /**
     * Returns an initiliazed instance of replacPlusTF component.
     * @return the initialized component instance
     */
    public TextField getReplacPlusTF() {
        if (replacPlusTF == null) {//GEN-END:|95-getter|0|95-preInit
            // write pre-init user code here
            replacPlusTF = new TextField("Change plus(+) to:", "" + replacePlus, 32, TextField.ANY);//GEN-LINE:|95-getter|1|95-postInit
            // write post-init user code here
        }//GEN-BEGIN:|95-getter|2|
        return replacPlusTF;
    }
    //</editor-fold>//GEN-END:|95-getter|2|
    /**
     * Returns a display instance.
     * @return the display instance.
     */
    public Display getDisplay() {
        return Display.getDisplay(this);
    }

    /**
     * Exits MIDlet.
     */
    public void exitMIDlet() {
        sm.writeSettings();
        switchDisplayable(null, null);
        destroyApp(true);
        notifyDestroyed();
    }

    /**
     * Called when MIDlet is started.
     * Checks whether the MIDlet have been already started and initialize/starts or resumes the MIDlet.
     */
    public void startApp() {
        if (midletPaused) {
            resumeMIDlet();
        } else {
            initialize();
            startMIDlet();
        }
        midletPaused = false;
    }

    /**
     * Called when MIDlet is paused.
     */
    public void pauseApp() {
        midletPaused = true;
    }

    /**
     * Called to signal the MIDlet to terminate.
     * @param unconditional if true, then the MIDlet has to be unconditionally terminated and all resources has to be released.
     */
    public void destroyApp(boolean unconditional) {
    }

    public void doDial(String number) {

        //remove danish +45 for localnumbers, replace + with 00 else

        if (number.indexOf(emptyPrefix) == 0) {
            number = number.substring(emptyPrefix.length());
        } else if (number.startsWith("+")) {
            number = replacePlus + number.substring(1);
        }

        getDialScreen().setText("dialing " + number);
        
        //replace # and * with their filenames
        number = number.replace('#', 'p');
        number = number.replace('*', 's');

        

        int len = number.length();
        char[] digits = number.toCharArray();
        for (int i = 0; i < len; i++) {
            dtmfSound(String.valueOf(digits[i]));
        }


    }

    private void dtmfSound(String tone) {

        // is it a valid tone ?
        if (dtmfvals.indexOf(tone) < 0) {
            return;
        }
        Player p = null;
        try {
            InputStream is = getClass().getResourceAsStream(tone + ".wav");
            p = Manager.createPlayer(is, "audio/X-wav");
            p.start();
            Thread.sleep(dtmfDuration);
            p.stop();
            Thread.sleep(dtmfPause);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (MediaException ex) {
            ex.printStackTrace();
        } finally {
            if (p != null) {
                p.deallocate();
            }
        }


    }
}
